
/******************************************************************************

Copyright (c) 1997, Andrew J. Weber, Jason P. Weber

Copyright information should have been included with this distribution
and may be found at ../meta/COPYRIGHT or obtained via email from weber@acm.org

******************************************************************************/

#include <bld/boolop.h>

/******************************************************************************
class BLD_NotOperation
******************************************************************************/
BLD_Value BLD_NotOperation::Perform(void) const
{
	const BLD_Value o = op->Perform();
	if (o.IsFalse())
	{
		return BLD_Value::truth;
	}
	return BLD_Value::falsehood;
}

GPL_String BLD_NotOperation::ToString(void) const
{
	GPL_String image;
	image.Printf("(!%s)", op->ToString().GetData());
	return image;
}

/******************************************************************************
class BLD_AndOperation
******************************************************************************/
BLD_Value BLD_AndOperation::Perform(void) const
{
	const BLD_Value l = left->Perform();
	const BLD_Value r = right->Perform();
	if (l.IsFalse() || r.IsFalse())
	{
		return BLD_Value::falsehood;
	}
	return BLD_Value::truth;
}

GPL_String BLD_AndOperation::ToString(void) const
{
	GPL_String image;
	image.Printf("(%s && %s)", left->ToString().GetData(), right->ToString().GetData());
	return image;
}

/******************************************************************************
class BLD_OrOperation
******************************************************************************/
BLD_Value BLD_OrOperation::Perform(void) const
{
	const BLD_Value l = left->Perform();
	const BLD_Value r = right->Perform();
	if (!l.IsFalse() || !r.IsFalse())
	{
		return BLD_Value::truth;
	}
	return BLD_Value::falsehood;
}

GPL_String BLD_OrOperation::ToString(void) const
{
	GPL_String image;
	image.Printf("(%s || %s)", left->ToString().GetData(), right->ToString().GetData());
	return image;
}

