
/******************************************************************************

Copyright (c) 1997, Andrew J. Weber, Jason P. Weber

Copyright information should have been included with this distribution
and may be found at ../meta/COPYRIGHT or obtained via email from weber@acm.org

******************************************************************************/

#include <bld/interp.h>

/******************************************************************************

******************************************************************************/
int main(const int argc, const char **argv, const char **envp)
{
	BLD_Interpreter interpreter((char **) envp);

	// Set up the aliases a la getopt(3C).
	WBA_ARGS.Set("BLD_DEBUG", "0", "Print debugging information", 1, "d");
	WBA_ARGS.Set("BLD_FILE", GPL_File::GetFullPathName(".bld"),
					"File of build commands", 1, "f");
	WBA_ARGS.Set("BLD_IGNORE_SYSTEM_FAILURES", "0",
					"Ignore failures of system command execution", 0);
	WBA_ARGS.Set("BLD_IGNORE_TARGET_FAILURES", "0",
					"Ignore failures of target builds", 0);
	WBA_ARGS.Set("BLD_NO_EXECUTION", "0", "Do not execute commands", 1, "n");
	WBA_ARGS.Set("BLD_PERSIST", "0", "Persist in the face of errors", 1, "k");
	WBA_ARGS.Set("BLD_PRINT_HELP", "0", "Print help and exit", 2, "h", "?");
	WBA_ARGS.Set("BLD_PRINT_VERSION", "0", "Print version and exit", 1, "v");
	WBA_ARGS.Set("BLD_QUIET", "0", "Do not print commands", 1, "q");
	WBA_ARGS.Set("BLD_SILENT", "0", "Do not print command output", 1, "s");
	WBA_ARGS.Set("BLD_TARGETS", "", "Initial build targets", 0);
	WBA_ARGS.Set("BLD_UNCONDITIONAL_REBUILD", "0",
					"Unconditionally rebuild all targets", 1, "u");
	WBA_ARGS.Set("BLD_VERBATIM", "0", "Print commands verbatim", 0);
	WBA_ARGS.Set("BLD_VERBOSE", "0", "Print lots of debugging information", 1, "V");

	// Provide scoping for aware objects.
	{
		GPL_Aware gplAware;
		WBA_Aware wbaAware;

		// Load only relevant environment variables.
		WBA_ENV.LoadEnvVariables(envp, FALSE);
	}

	// Load all arguments.
	if (!WBA_ENV.LoadCommandLine(argc, argv, TRUE))
	{
		WBA_APP->Printf("%s", WBA_APP->GetUsage());
		WBA_APP->SetExitCode(-1);
		WBA_APP->Exit();
	}

	return interpreter.Main();
}

