#ifndef BLD_RELOP_H
#define BLD_RELOP_H

/******************************************************************************

Copyright (c) 1997, Andrew J. Weber, Jason P. Weber

Copyright information should have been included with this distribution
and may be found at ../meta/COPYRIGHT or obtained via email from weber@acm.org

******************************************************************************/

#include <bld/boolop.h>

/***********************************************************************
class BLD_EqualOperation

Equivalence.
***********************************************************************/
class BLD_EqualOperation : public BLD_BinaryOperation
{
	public:
		BLD_EqualOperation(BLD_Operation *l, BLD_Operation *r)
			: BLD_BinaryOperation(l, r) {}
		virtual ~BLD_EqualOperation(void) {}

		virtual BLD_Value Perform(void) const;
		virtual GPL_String ToString(void) const;
};

/***********************************************************************
class BLD_NotEqualOperation

Not equivalence.
***********************************************************************/
class BLD_NotEqualOperation : public BLD_BinaryOperation
{
	public:
		BLD_NotEqualOperation(BLD_Operation *l, BLD_Operation *r)
			: BLD_BinaryOperation(l, r) {}
		virtual ~BLD_NotEqualOperation(void) {}

		virtual BLD_Value Perform(void) const;
		virtual GPL_String ToString(void) const;
};

/***********************************************************************
class BLD_LessOperation

Less than.
***********************************************************************/
class BLD_LessOperation : public BLD_BinaryOperation
{
	public:
		BLD_LessOperation(BLD_Operation *l, BLD_Operation *r)
			: BLD_BinaryOperation(l, r) {}
		virtual ~BLD_LessOperation(void) {}

		virtual BLD_Value Perform(void) const;
		virtual GPL_String ToString(void) const;
};

/***********************************************************************
class BLD_LessEqualOperation

Less than or equal to.
***********************************************************************/
class BLD_LessEqualOperation : public BLD_BinaryOperation
{
	public:
		BLD_LessEqualOperation(BLD_Operation *l, BLD_Operation *r)
			: BLD_BinaryOperation(l, r) {}
		virtual ~BLD_LessEqualOperation(void) {}

		virtual BLD_Value Perform(void) const;
		virtual GPL_String ToString(void) const;
};

/***********************************************************************
class BLD_GreaterOperation

Greater than.
***********************************************************************/
class BLD_GreaterOperation : public BLD_BinaryOperation
{
	public:
		BLD_GreaterOperation(BLD_Operation *l, BLD_Operation *r)
			: BLD_BinaryOperation(l, r) {}
		virtual ~BLD_GreaterOperation(void) {}

		virtual BLD_Value Perform(void) const;
		virtual GPL_String ToString(void) const;
};

/***********************************************************************
class BLD_GreaterEqualOperation

Greater than or equal to.
***********************************************************************/
class BLD_GreaterEqualOperation : public BLD_BinaryOperation
{
	public:
		BLD_GreaterEqualOperation(BLD_Operation *l, BLD_Operation *r)
			: BLD_BinaryOperation(l, r) {}
		virtual ~BLD_GreaterEqualOperation(void) {}

		virtual BLD_Value Perform(void) const;
		virtual GPL_String ToString(void) const;
};

#endif /* BLD_RELOP_H */
