#ifndef BLD_SCOPE_H
#define BLD_SCOPE_H

/******************************************************************************

Copyright (c) 1997, Andrew J. Weber, Jason P. Weber

Copyright information should have been included with this distribution
and may be found at ../meta/COPYRIGHT or obtained via email from weber@acm.org

******************************************************************************/

#include <gpl/gpl.h>
#include <bld/value.h>
#include <bld/rule.h>
#include <bld/target.h>

/***********************************************************************
class BLD_Scope

***********************************************************************/
class BLD_Scope
{
	public:
		BLD_Scope(void);
		BLD_Scope(const GPL_String & n);
		virtual ~BLD_Scope(void);

		GPL_Boolean operator==(const BLD_Scope & s) const
		{
			return name == s.name && variables == s.variables;
		}

		inline const GPL_String & GetName(void) const { return name; }
		void GetValues(GPL_Map<GPL_String, BLD_Value> & values) const;

		GPL_Boolean LookUp(const GPL_String & string, BLD_Value & value) const;
		GPL_Boolean Insert(const GPL_String & string, const BLD_Value & value);

		GPL_Boolean AddRule(const GPL_String & string, const BLD_RuleType type,
							const OpArray & ops);
		GPL_Boolean CreateTarget(BLD_Target & target);

		GPL_String ToString(void) const;

	protected:
		GPL_String name;
		GPL_Map<GPL_String, BLD_Value> variables;
		// Gack!  This is the slowest possible structure, but
		// it is required in order to handle both variables
		// and patterns.
		GPL_List< GPL_Pointer<BLD_RuleBase> > rules;
};

#endif /* BLD_SCOPE_H */
