
/******************************************************************************

COPYRIGHT_HEADER

******************************************************************************/

#include <bld/value.h>
#include <bld/op.h>

/***********************************************************************
class BLD_Value
***********************************************************************/
const GPL_String BLD_Value::falsehood = "0";
const GPL_String BLD_Value::truth = "1";
GPL_RegularExpression BLD_Value::numericDataPattern("^[-+]?[0-9]+$");

GPL_Boolean BLD_Value::IsFalse(void) const
{
	return 0 == GetCount() || operator[](0).IsNull() || BLD_Value::falsehood == operator[](0);
}

GPL_String BLD_Value::GetString(void) const
{
	return GPL_String::Join(" ", (const GPL_Array<GPL_String> &) *this);
}

long BLD_Value::Compare(const BLD_Value & value) const
{
	register const unsigned long m = GetCount();
	register const unsigned long n = value.GetCount();
	if (m == n)
	{
		register long j = 0;
		for (register unsigned long i = 0; m > i; ++i)
		{
			// If both values are numeric...
			if (numericDataPattern.Matches(operator[](i)) &&
				numericDataPattern.Matches(value[i]))
			{
				j = (long) (atof(value[i].GetData()) -
							atof(operator[](i).GetData()));
			}

			// If either value is *not* numeric...
			else
			{
				j = operator[](i).Compare(value[i]);
			}

			// Like Jerry Seinfeld's relationships,
			// stop at the first disagreement.
			if (0 != j)
			{
				break;
			}
		}
		return j;
	}
	return m - n;
}

