
#define SPA_TRAPEZOID	2
#define SPA_MIDPOINT	3
#define SPA_MIDINF		4
#define SPA_MIDEXP		5
#define SPA_MIDUNIT		6

#define SPA_MIDYDIFF	11

class SPA_Function1D
{
	public:
		double	maxtrap;
		double 	maxyval;
	private:
		char 	rule;
		double	accuracy;
		long	maxDepth;
		long	minDepth;
static	long	defaultMaxDepth;
static	long	defaultMinDepth;
		double	startDial;
		double	tune;
		double	recipeS;
		GPL_File	file;
		GPL_String	filename;
	public:
		SPA_Function1D();
virtual	~SPA_Function1D();

		void Set(char r);
		void Set(char r, double a);
		void Set(char r, double a, long max, long min);
static	void SetDefaultDepths(long max, long min);
		void WriteToFile(const GPL_String &fname)
		{
			file.Open(fname, OSD_FILE_WRITE);
		};

virtual	double Function(double x) = 0;

		double Rule(double a, double b);

		/* Adaptive Handrolled Full Retry Algorithms */
		double Dialin(double start, double end);
		double DialFunction(double start, double end, double tol, double a0);
		double MidpointYdiff(double start, double end, double tol, double a0);

		/* Numerical Recipe Based */
		double Recipe(double a, double b);
		double Choose(double a, double b, long n);
		double Trapezoid(double a, double b, long n);
		double Midpoint(double a, double b, long n);
		double FunctionInf(double x);
		double MidInf(double a, double b, long n);
		double FunctionExp(double x);
		double MidExp(double a, double b, long n);
		double FunctionUnit(double x,  double a, double lambda);
		double MidUnit(double a, double b, long n);
};

