/* 	@(#)lmdif1.h	1.2	 */
/* #include "f2c.h" */
#ifndef _lmdif1_h_
#define _lmdif1_h_

#define min(a,b) ((a) <= (b) ? (a) : (b))
#define max(a,b) ((a) >= (b) ? (a) : (b))
#define dmin(a,b) (doublereal)min(a,b)
#define dmax(a,b) (doublereal)max(a,b)

/* error codes */
#define INFO_ERR_INPUT   ((int)0)     /* improper input */
#define INFO_SUMSQ       ((int)1)     /* sum of sq. relative err at most tol. */
#define INFO_XSOL        ((int)2)     /* sum of sq. between x and soln at most tol. */
#define INFO_XSOL_SUMSQ  ((int)3)     /* both INFO_SUMSQ and INFO_XSOL */
#define INFO_ORTHO       ((int)4)     /* fvec orthogonal to jacobian */
#define INFO_MAX_ITER    ((int)5)     /* number of iteration > (200)*(n+1) */
#define INFO_TOL_SQ      ((int)6)     /* tolerance too small for reduction in sumsq */
#define INFO_TOL_XSOL    ((int)7)     /* tolerance too small for soln improvement */


extern double dpmpar_(int *i)  ;
extern double enorm_(int *n, 
		  double *x)  ;
extern int lmdif1_(  int (*fcn)(void *user, int *m,
				int *n,
				double *x, 
				double *fvec, 
				int *iflag), 
	      int *m, 
	      int *n, 
	      double *x, 
	      double *fvec, 
	      double *tol, 
	      int *info, 
	      int *iwa, 
	      double *wa, 
	      int *lwa,
          void *user)  ;
int lmdif_(   int (*fcn)(void *user, int *m,
			 int *n,
			 double *x, 
			 double *fvec, 
			 int *iflag), 
	      int *m, 
	      int *n, 
	      double *x, 
	      double *fvec, 
	      double *ftol, 
	      double *xtol, 
	      double *gtol, 
	      int *maxfev, 
	      double *epsfcn, 
	      double *diag, 
	      int *mode, 
	      double *factor, 
	      int *nprint, 
	      int *info, 
	      int *nfev, 
	      double *fjac, 
	      int *ldfjac, 
	      int *ipvt, 
	      double *qtf, 
	      double *wa1, 
	      double *wa2, 
	      double *wa3, 
	      double *wa4,
          void *user) ;
extern int fdjac2_(int (*fcn)(void *user, int *m,
			      int *n,
			      double *x, 
			      double *fvec, 
			      int *iflag), 
		   int *m, 
		   int *n, 
		   double *x, 
		   double *fvec, 
		   double *fjac, 
		   int *ldfjac, 
		   int *iflag, 
		   double *epsfcn, 
		   double *wa,
           void *user) ;

extern int qrfac_(int *m, 
		  int *n, 
		  double *a, 
		  int *lda, 
		  int *pivot, 
		  int *ipvt, 
		  int *lipvt, 
		  double *rdiag, 
		  double *acnorm,
		  double *wa) ;

extern int lmpar_( int *n, 
		   double *r, 
		   int *ldr, 
		   int *ipvt, 
		   double *diag, 
		   double *qtb, 
		   double *delta, 
		   double *par, 
		   double *x, 
		   double *sdiag,
		   double *wa1, 
		   double *wa2) ;
extern int qrsolv_(int *n, 
		   double *r, 
		   int *ldr, 
		   int *ipvt, 
		   double *diag, 
		   double *qtb, 
		   double *x, 
		   double *sdiag, 
		   double *wa) ;
#endif
