#include <spa/spa.h>

class TestArea : public SPA_Integrate
{
	public:
		double lastRun;
		GPL_Boolean run;
	public:
		TestArea()
		{
			run = FALSE;
		}
virtual	~TestArea()
		{
		}

		operator double(void)
		{
			if(run)
			{
				return lastRun;
			}
			else
			{
				return Integrate();
			}
		}

		double Integrate()
		{
			lastRun = Quadrature(0.0, 1000.0, 1e-3, 0, 0.0);
			//lastRun = Trapezoidx(0.0, 10.0, 1e-2);
			run = TRUE;
			return lastRun;
		}

		double Function(double z)
		{
			//return z*z*z*z-z*z*z;
			//return sin(z);
			return exp(-z);
		}
};

class TestFunction : public SPA_Function1D
{
	public:
		TestFunction(){}
virtual	~TestFunction(){}
		double Function(double z)
		{
			//return sin(z);
			return exp(-z);
		}
};

int main(const int argc, const char *argv[], const char *envp[])
{
	TestArea test_area;
	double area;
	long t;
	t = osdTimer();
	area = test_area;
	t = osdTimer() - t;
	fprintf(stdout,"0: area %.12g %d\n", area, t);

	TestFunction test_function;
	t = osdTimer();
	test_function.Set(SPA_MIDYDIFF, 1e-3, 20 , 5);
	area = test_function.Rule(0.0, 1000.0);
	t = osdTimer() - t;
	fprintf(stdout,"1: area %.12g %d\n", area, t);

	t = osdTimer();
	test_function.Set(SPA_MIDEXP, 1e-3, 20 , 5);
	area = test_function.Rule(0.0, 1000.0);
	t = osdTimer() - t;
	fprintf(stdout,"2: area %.12g %d\n", area, t);

	t = osdTimer();
	test_function.Set(SPA_MIDUNIT, 1e-3, 20 , 5);
	area = test_function.Rule(0.0, 1000.0);
	t = osdTimer() - t;
	fprintf(stdout,"3: area %.12g %d\n", area, t);
	return 0;
}

